<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;adler-1.0.2&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../adler/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
</pre><pre class="rust"><code><span class="doccomment">//! Adler-32 checksum implementation.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This implementation features:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - Permissively licensed (0BSD) clean-room implementation.</span>
<span class="doccomment">//! - Zero dependencies.</span>
<span class="doccomment">//! - Zero `unsafe`.</span>
<span class="doccomment">//! - Decent performance (3-4 GB/s).</span>
<span class="doccomment">//! - `#![no_std]` support (with `default-features = false`).</span>

<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/adler/1.0.2&quot;</span>)]</span>
<span class="comment">// Deny a few warnings in doctests, since rustdoc `allow`s many warnings by default</span>
<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">test</span>(<span class="ident">attr</span>(<span class="ident">deny</span>(<span class="ident">unused_imports</span>, <span class="ident">unused_must_use</span>))))]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">docsrs</span>, <span class="ident">feature</span>(<span class="ident">doc_cfg</span>))]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">missing_debug_implementations</span>)]</span>
<span class="attribute">#![<span class="ident">forbid</span>(<span class="ident">unsafe_code</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>), <span class="ident">no_std</span>)]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">core</span> <span class="kw">as</span> <span class="ident">std</span>;

<span class="kw">mod</span> <span class="ident">algo</span>;

<span class="kw">use</span> <span class="ident">std::hash::Hasher</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">std::io</span>::{<span class="self">self</span>, <span class="ident">BufRead</span>};

<span class="doccomment">/// Adler-32 checksum calculator.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// An instance of this type is equivalent to an Adler-32 checksum: It can be created in the default</span>
<span class="doccomment">/// state via [`new`] (or the provided `Default` impl), or from a precalculated checksum via</span>
<span class="doccomment">/// [`from_checksum`], and the currently stored checksum can be fetched via [`checksum`].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This type also implements `Hasher`, which makes it easy to calculate Adler-32 checksums of any</span>
<span class="doccomment">/// type that implements or derives `Hash`. This also allows using Adler-32 in a `HashMap`, although</span>
<span class="doccomment">/// that is not recommended (while every checksum is a hash function, they are not necessarily a</span>
<span class="doccomment">/// good one).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Basic, piecewise checksum calculation:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use adler::Adler32;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let mut adler = Adler32::new();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// adler.write_slice(&amp;[0, 1, 2]);</span>
<span class="doccomment">/// adler.write_slice(&amp;[3, 4, 5]);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(adler.checksum(), 0x00290010);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Using `Hash` to process structures:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use std::hash::Hash;</span>
<span class="doccomment">/// use adler::Adler32;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// #[derive(Hash)]</span>
<span class="doccomment">/// struct Data {</span>
<span class="doccomment">///     byte: u8,</span>
<span class="doccomment">///     word: u16,</span>
<span class="doccomment">///     big: u64,</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let mut adler = Adler32::new();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let data = Data { byte: 0x1F, word: 0xABCD, big: !0 };</span>
<span class="doccomment">/// data.hash(&amp;mut adler);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // hash value depends on architecture endianness</span>
<span class="doccomment">/// if cfg!(target_endian = &quot;little&quot;) {</span>
<span class="doccomment">///     assert_eq!(adler.checksum(), 0x33410990);</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// if cfg!(target_endian = &quot;big&quot;) {</span>
<span class="doccomment">///     assert_eq!(adler.checksum(), 0x331F0990);</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`new`]: #method.new</span>
<span class="doccomment">/// [`from_checksum`]: #method.from_checksum</span>
<span class="doccomment">/// [`checksum`]: #method.checksum</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Adler32</span> {
    <span class="ident">a</span>: <span class="ident">u16</span>,
    <span class="ident">b</span>: <span class="ident">u16</span>,
}

<span class="kw">impl</span> <span class="ident">Adler32</span> {
    <span class="doccomment">/// Creates a new Adler-32 instance with default state.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::default</span>()
    }

    <span class="doccomment">/// Creates an `Adler32` instance from a precomputed Adler-32 checksum.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This allows resuming checksum calculation without having to keep the `Adler32` instance</span>
    <span class="doccomment">/// around.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// # use adler::Adler32;</span>
    <span class="doccomment">/// let parts = [</span>
    <span class="doccomment">///     &quot;rust&quot;,</span>
    <span class="doccomment">///     &quot;acean&quot;,</span>
    <span class="doccomment">/// ];</span>
    <span class="doccomment">/// let whole = adler::adler32_slice(b&quot;rustacean&quot;);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut sum = Adler32::new();</span>
    <span class="doccomment">/// sum.write_slice(parts[0].as_bytes());</span>
    <span class="doccomment">/// let partial = sum.checksum();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // ...later</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut sum = Adler32::from_checksum(partial);</span>
    <span class="doccomment">/// sum.write_slice(parts[1].as_bytes());</span>
    <span class="doccomment">/// assert_eq!(sum.checksum(), whole);</span>
    <span class="doccomment">/// ```</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_checksum</span>(<span class="ident">sum</span>: <span class="ident">u32</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">Adler32</span> {
            <span class="ident">a</span>: <span class="ident">sum</span> <span class="kw">as</span> <span class="ident">u16</span>,
            <span class="ident">b</span>: (<span class="ident">sum</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">16</span>) <span class="kw">as</span> <span class="ident">u16</span>,
        }
    }

    <span class="doccomment">/// Returns the calculated checksum at this point in time.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">checksum</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
        (<span class="ident">u32::from</span>(<span class="self">self</span>.<span class="ident">b</span>) <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">16</span>) <span class="op">|</span> <span class="ident">u32::from</span>(<span class="self">self</span>.<span class="ident">a</span>)
    }

    <span class="doccomment">/// Adds `bytes` to the checksum calculation.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If efficiency matters, this should be called with Byte slices that contain at least a few</span>
    <span class="doccomment">/// thousand Bytes.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">write_slice</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="self">self</span>.<span class="ident">compute</span>(<span class="ident">bytes</span>);
    }
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">Adler32</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">default</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">Adler32</span> { <span class="ident">a</span>: <span class="number">1</span>, <span class="ident">b</span>: <span class="number">0</span> }
    }
}

<span class="kw">impl</span> <span class="ident">Hasher</span> <span class="kw">for</span> <span class="ident">Adler32</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">finish</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        <span class="ident">u64::from</span>(<span class="self">self</span>.<span class="ident">checksum</span>())
    }

    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="self">self</span>.<span class="ident">write_slice</span>(<span class="ident">bytes</span>);
    }
}

<span class="doccomment">/// Calculates the Adler-32 checksum of a byte slice.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is a convenience function around the [`Adler32`] type.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Adler32`]: struct.Adler32.html</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">adler32_slice</span>(<span class="ident">data</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">h</span> <span class="op">=</span> <span class="ident">Adler32::new</span>();
    <span class="ident">h</span>.<span class="ident">write_slice</span>(<span class="ident">data</span>);
    <span class="ident">h</span>.<span class="ident">checksum</span>()
}

<span class="doccomment">/// Calculates the Adler-32 checksum of a `BufRead`&#39;s contents.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The passed `BufRead` implementor will be read until it reaches EOF (or until it reports an</span>
<span class="doccomment">/// error).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// If you only have a `Read` implementor, you can wrap it in `std::io::BufReader` before calling</span>
<span class="doccomment">/// this function.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Errors</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Any error returned by the reader are bubbled up by this function.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```no_run</span>
<span class="doccomment">/// # fn run() -&gt; Result&lt;(), Box&lt;dyn std::error::Error&gt;&gt; {</span>
<span class="doccomment">/// use adler::adler32;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// use std::fs::File;</span>
<span class="doccomment">/// use std::io::BufReader;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let file = File::open(&quot;input.txt&quot;)?;</span>
<span class="doccomment">/// let mut file = BufReader::new(file);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// adler32(&amp;mut file)?;</span>
<span class="doccomment">/// # Ok(()) }</span>
<span class="doccomment">/// # fn main() { run().unwrap() }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">docsrs</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)))]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">adler32</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">BufRead</span><span class="op">&gt;</span>(<span class="kw-2">mut</span> <span class="ident">reader</span>: <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">io::Result</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">h</span> <span class="op">=</span> <span class="ident">Adler32::new</span>();
    <span class="kw">loop</span> {
        <span class="kw">let</span> <span class="ident">len</span> <span class="op">=</span> {
            <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">reader</span>.<span class="ident">fill_buf</span>()<span class="question-mark">?</span>;
            <span class="kw">if</span> <span class="ident">buf</span>.<span class="ident">is_empty</span>() {
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">h</span>.<span class="ident">checksum</span>());
            }

            <span class="ident">h</span>.<span class="ident">write_slice</span>(<span class="ident">buf</span>);
            <span class="ident">buf</span>.<span class="ident">len</span>()
        };
        <span class="ident">reader</span>.<span class="ident">consume</span>(<span class="ident">len</span>);
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">zeroes</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[]), <span class="number">1</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>]), <span class="number">1</span> <span class="op">|</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">16</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>, <span class="number">0</span>]), <span class="number">1</span> <span class="op">|</span> <span class="number">2</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">16</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>; <span class="number">100</span>]), <span class="number">0x00640001</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>; <span class="number">1024</span>]), <span class="number">0x04000001</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>; <span class="number">1024</span> <span class="op">*</span> <span class="number">1024</span>]), <span class="number">0x00f00001</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">ones</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0xff</span>; <span class="number">1024</span>]), <span class="number">0x79a6fc2e</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0xff</span>; <span class="number">1024</span> <span class="op">*</span> <span class="number">1024</span>]), <span class="number">0x8e88ef11</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">mixed</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">1</span>]), <span class="number">2</span> <span class="op">|</span> <span class="number">2</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">16</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">40</span>]), <span class="number">41</span> <span class="op">|</span> <span class="number">41</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">16</span>);

        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0xA5</span>; <span class="number">1024</span> <span class="op">*</span> <span class="number">1024</span>]), <span class="number">0xd5009ab1</span>);
    }

    <span class="doccomment">/// Example calculation from https://en.wikipedia.org/wiki/Adler-32.</span>
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">wiki</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">adler32_slice</span>(<span class="string">b&quot;Wikipedia&quot;</span>), <span class="number">0x11E60398</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">resume</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">adler</span> <span class="op">=</span> <span class="ident">Adler32::new</span>();
        <span class="ident">adler</span>.<span class="ident">write_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0xff</span>; <span class="number">1024</span>]);
        <span class="kw">let</span> <span class="ident">partial</span> <span class="op">=</span> <span class="ident">adler</span>.<span class="ident">checksum</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">partial</span>, <span class="number">0x79a6fc2e</span>); <span class="comment">// from above</span>
        <span class="ident">adler</span>.<span class="ident">write_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0xff</span>; <span class="number">1024</span> <span class="op">*</span> <span class="number">1024</span> <span class="op">-</span> <span class="number">1024</span>]);
        <span class="macro">assert_eq!</span>(<span class="ident">adler</span>.<span class="ident">checksum</span>(), <span class="number">0x8e88ef11</span>); <span class="comment">// from above</span>

        <span class="comment">// Make sure that we can resume computing from the partial checksum via `from_checksum`.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">adler</span> <span class="op">=</span> <span class="ident">Adler32::from_checksum</span>(<span class="ident">partial</span>);
        <span class="ident">adler</span>.<span class="ident">write_slice</span>(<span class="kw-2">&amp;</span>[<span class="number">0xff</span>; <span class="number">1024</span> <span class="op">*</span> <span class="number">1024</span> <span class="op">-</span> <span class="number">1024</span>]);
        <span class="macro">assert_eq!</span>(<span class="ident">adler</span>.<span class="ident">checksum</span>(), <span class="number">0x8e88ef11</span>); <span class="comment">// from above</span>
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">bufread</span>() {
        <span class="kw">use</span> <span class="ident">std::io::BufReader</span>;
        <span class="kw">fn</span> <span class="ident">test</span>(<span class="ident">data</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">checksum</span>: <span class="ident">u32</span>) {
            <span class="comment">// `BufReader` uses an 8 KB buffer, so this will test buffer refilling.</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">BufReader::new</span>(<span class="ident">data</span>);
            <span class="kw">let</span> <span class="ident">real_sum</span> <span class="op">=</span> <span class="ident">adler32</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">buf</span>).<span class="ident">unwrap</span>();
            <span class="macro">assert_eq!</span>(<span class="ident">checksum</span>, <span class="ident">real_sum</span>);
        }

        <span class="ident">test</span>(<span class="kw-2">&amp;</span>[], <span class="number">1</span>);
        <span class="ident">test</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>; <span class="number">1024</span>], <span class="number">0x04000001</span>);
        <span class="ident">test</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>; <span class="number">1024</span> <span class="op">*</span> <span class="number">1024</span>], <span class="number">0x00f00001</span>);
        <span class="ident">test</span>(<span class="kw-2">&amp;</span>[<span class="number">0xA5</span>; <span class="number">1024</span> <span class="op">*</span> <span class="number">1024</span>], <span class="number">0xd5009ab1</span>);
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="adler" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>